// 创建弹窗
import React, { useRef, useEffect, useState } from 'react';
import { createForm, FormPathPattern, onFieldReact } from '@formily/core';
import { createSchemaField } from '@formily/react';
import Modal, { ModalProps } from '@/components/Modal';
import { Form, FormItem, Input, Select } from '@formily/antd';
import { updateUser } from '@/services/system/accountManage';
import { getRoleList } from '@/services/system/role';
import { action } from '@formily/reactive';

interface EditAccountModalPropsType extends ModalProps {
  editModalData: any;
  onCancel: () => void;
  onOk: () => void;
}

const SchemaField = createSchemaField({
  components: {
    FormItem,
    Input,
    Select,
  },
});

const EditAccountModal = ({
  onOk,
  onCancel,
  editModalData,
  ...rest
}: EditAccountModalPropsType) => {
  const [roleListData, setRoleListData] = useState({});

  const getSelectData = async () => {
    const list = await getRoleList({ page: 1, size: 10 });
    setRoleListData(list);
  };

  const useAsyncDataSource = (
    pattern: FormPathPattern,
    service: (field: Field) => Promise<{ label: string; value: any }[]>,
  ) => {
    onFieldReact(pattern, (field) => {
      service(field).then(
        action.bound((data) => {
          field.dataSource = data;
        }),
      );
    });
  };

  const form = createForm({
    effects: () => {
      // eslint-disable-next-line react-hooks/rules-of-hooks
      useAsyncDataSource('role', async (field) => {
        getSelectData();
        const list = roleListData;
        const option = [];
        for (let index = 0; index < list.items.length; index++) {
          const element = list.items[index];
          const item = {
            label: element.role_name,
            value: element.id,
          };
          option.push(item);
        }
        return option;
      });
    },
  });

  useEffect(() => {
    form.setInitialValues(editModalData);
  });

  const handleOk = async () => {
    form.submit(async () => {
      onOk();
      const formState = form.getFormState();
      formState.values.role = parseInt(formState.values.role);
      await updateUser(formState.values);
    });
  };

  const handleCancel = () => {
    onCancel();
  };

  return (
    <Modal title="编辑管理账号" onOk={handleOk} onCancel={handleCancel} width={800} {...rest}>
      <Form form={form} labelCol={4} wrapperCol={18}>
        <SchemaField>
          <SchemaField.String
            name="name"
            title="账号名"
            required
            x-disabled
            x-decorator="FormItem"
            x-component="Input"
            x-component-props={{
              placeholder: '请输入账号名',
            }}
          />
          <SchemaField.String
            name="password"
            title="密码"
            required
            x-decorator="FormItem"
            x-component="Input"
            x-component-props={{
              placeholder: '请输入密码',
            }}
          />
          <SchemaField.String
            name="role"
            title="角色"
            required
            x-decorator="FormItem"
            x-component="Select"
            x-component-props={{
              placeholder: '请选择角色',
            }}
          />
        </SchemaField>
      </Form>
    </Modal>
  );
};

export default EditAccountModal;
